



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Netty---入门程序，搭建Websocket 服务器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Netty---入门程序，搭建Websocket 服务器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 23:16:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Netty 常用的场景：</p>
<p>　　　　1.充当HTTP 服务器，但Netty 并没有遵循servlet 的标准，反而实现了自己的一套标准进行Http 服务；</p>
<p>　　　　2,RPC 远程调用，在分布式系统中常用的框架</p>
<p>　　　　3.Socket 长连接</p>
<p>　</p>
<p>需要了解的名词</p>
<p>　1.<strong>NioEventLoopGroup: 对线程的控制，</strong><strong>线程组,事件循环组,死循环,需要定义两个线程组，一个只用于接收客户端的请求，一个负责具体的处理</strong></p>
<p><strong>　2.Bootstrap :对服务启动的封装，可以很轻松的启动服务管道，进行服务的启动</strong></p>
<p><strong>　3.Channel:<strong>渠道</strong>，每一个请求都会形成一个渠道</strong></p>
<p><strong>　4.initChannel:连接一旦被创建，就会执行initChannel方法</strong></p>
<p><strong>　5.ChannelPipline:连接的管道，里面装有很多的<strong>ChannelHandler处理器（第6）</strong></strong></p>
<p><strong>　6.ChannelHandler:定义我们自己的处理器，因为<strong>流程进行到这里我们的请求已经进来了</strong>，需要我们进行自己的逻辑处理与响应，相当于filter 一样； netty也提供了很多的处理器；</strong></p>
<p><strong>　7.ByteBuf:很重要，以后详细讲解</strong></p>
<p><strong>　8.ChannelGroup :用来存放一个一个的Channel 对象的Channel 组 ,可以通过&nbsp; new DefaultChannelGroup(GlobalEventExecutor.INSTANCE);进行获取</strong></p>
<p><strong>接下来是示例代码：我们目前刚接触，我们先不用管它里面具体怎么实现的，只要先对netty 有一个全局的认识，知道它的执行流程就可以，知道执行流程后再深入学习每一步的作用，这样我们就不会太迷茫</strong></p>
<p><strong>基本上，所有netty 编程中都会遵循以下三点：</strong></p>
<p><strong>　　1. 创建线程组,即EventLoopGroup</strong></p>
<p><strong>　　2.进行服务启动类，即bootstrap</strong></p>
<p><strong>　　3.针对自己的业务，创建自己的Handler</strong></p>
<p>1.我们的启动类</p>
<div>
<pre class="prettyprint linenums">public class WebSocketService {

    public static void main(String[] args) throws Exception {

        //一样，定义线程组<br />
        EventLoopGroup boosGroup =new NioEventLoopGroup();<br />
        EventLoopGroup workGroup =new NioEventLoopGroup();

        //服务启动类<br />
        try<br />
        {<br />
        ServerBootstrap bootstrap=new ServerBootstrap();<br />
        bootstrap.group(boosGroup,workGroup)<br />
                .channel(NioServerSocketChannel.class)<br />
                //添加日志<br />
                .handler(new LoggingHandler(LogLevel.INFO))<br />
                .childHandler(new WebSocketInitializer());

        //端口绑定<br />
        ChannelFuture channelFuture=bootstrap.bind(9077).sync();<br />
        channelFuture.channel().closeFuture().sync();<br />
        }<br />
        finally {<br />
            boosGroup.shutdownGracefully();<br />
            workGroup.shutdownGracefully();

        }

    }<br />
}</pre>
</div>
<p>2.初始化器，用来存放Hander 的</p>
<div>
<pre class="prettyprint linenums">/**<br />
 * initializer 初始化器<br />
 * @author cys<br />
 *<br />
 */<br />
public class WebSocketInitializer extends ChannelInitializer&lt;SocketChannel&gt; {

    @Override<br />
    protected void initChannel(SocketChannel ch) throws Exception {

        ChannelPipeline pip =ch.pipeline();

        //=====websocket 是基于http协议基础之上的，所以要有http的支持=======//<br />
        //编解码器<br />
        pip.addLast(new HttpServerCodec());<br />
        //对大数据的支持<br />
        pip.addLast(new ChunkedWriteHandler());<br />
        // 对httpMessage进行聚合，聚合成FullHttpRequest或FullHttpResponse<br />
        // 几乎在netty中的编程，都会使用到此hanler<br />
        pip.addLast(new HttpObjectAggregator(1024*64));

        //This handler does all the heavy lifting for you to run a websocket server.<br />
        //这个handler 做了所有的繁重的工作，对于你运行的websocket服务器<br />
        //处理了frame 的 close ping pang binary text ，运行中并带到下一个关于你的实现的handler<br />
        pip.addLast(new WebSocketServerProtocolHandler("/ws"));//===&gt;ws://localhost:8066/ws

        //自定义自己的处理类,WebSocketServerProtocolHandler 会将数据帧带到你的handler中

        pip.addLast(new WebSocketMyHandler());

    }

}</pre>
</div>
<p>3.定义自己的Handler ，也就是自己的逻辑处理</p>
<div>
<pre class="prettyprint linenums">/**<br />
 * webSocket 自定义handler<br />
 * webSocket 对于数据的传输都是基于Frame（帧）的 ，关于frame 一共有五种类型，遵循RFC标准,netty 实现了这五种标准，所有netty 对websocket 有很好的支持<br />
 *                                 1.BinaryWebSocketFrame<br />
 *                                 2.TextWebSocketFrame<br />
 *                                 3.PongWebSocketFrame<br />
 *                                 4.PingWebSocketFrame<br />
 *                                 5.CloseWebSocketFrame<br />
 * ping、pong 的操作，对应的是 WebSocket 的两个控制帧 ==心跳<br />
 *<br />
 * @author cys<br />
 *<br />
 */<br />
public class WebSocketMyHandler extends SimpleChannelInboundHandler&lt;TextWebSocketFrame&gt; {

    //当前的channel 组<br />
    private static ChannelGroup channelGroup =new DefaultChannelGroup(GlobalEventExecutor.INSTANCE);

    @Override<br />
    protected void channelRead0(ChannelHandlerContext ctx, TextWebSocketFrame msg) throws Exception {

        Channel ch =ctx.channel();<br />
        //msg.text()接收客户端的消息<br />
        String text=msg.text();<br />
        System.out.println("收到消息"+text);<br />
        for(Channel self :channelGroup) {

            if(ch ==self) {<br />
                ch.writeAndFlush(new TextWebSocketFrame("我：===&gt;"+text));

            }<br />
            else {<br />
                self.writeAndFlush(new TextWebSocketFrame(ch.remoteAddress()+"===&gt;"+text));<br />
            }<br />
        }

    }

    /**<br />
     * 当有新的Channel连接 时候会触发<br />
     */<br />
    @Override<br />
    public void handlerAdded(ChannelHandlerContext ctx) throws Exception {

        Channel ch = ctx.channel();

        channelGroup.writeAndFlush(new TextWebSocketFrame(ch.remoteAddress()+"---上线"));<br />
        System.out.println(ch.remoteAddress()+"已经连接");<br />
        channelGroup.add(ctx.channel());<br />
    }

    /**<br />
     * 连接断开的时候触发<br />
     */<br />
    @Override<br />
    public void handlerRemoved(ChannelHandlerContext ctx) throws Exception {

        Channel ch = ctx.channel();

        System.out.println(new TextWebSocketFrame(ch.remoteAddress()+"已经断开"));<br />
        channelGroup.writeAndFlush(ch.remoteAddress()+"---下线");<br />
    }

    /**<br />
     * 出现异常时候触发,关闭当前连接<br />
     */

    @Override<br />
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {

         ctx.channel().close();<br />
    }

}</pre>
</div>
<p>4.因为websocket 是基于HTML5的，所以客户端就是我们支持websocket的浏览器，</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;<br />
&lt;head&gt;<br />
&lt;meta charset="UTF-8"&gt;<br />
&lt;title&gt;web socket连接&lt;/title&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;

&lt;div&gt;发送消息&lt;/div&gt;<br />
&lt;input type="text" id="msgContent"/&gt;<br />
&lt;input type="button"  value="send" onclick="CHAT.chat()"/&gt;<br />
&lt;div&gt;接收消息&lt;/div&gt;<br />
&lt;div id="reciveMsg" style="background-color:pink"&gt;&lt;/div&gt;

&lt;script type="text/javascript"&gt;

window.CHAT ={<br />
        socket:null,<br />
        init: function(){<br />
            if(window.WebSocket){<br />
                CHAT.socket =new WebSocket("ws://10.9.121.91:9077/ws");<br />
                CHAT.socket.onopen = CHAT.onopen,<br />
                CHAT.socket.onclose =CHAT.onclose,<br />
                CHAT.socket.onerror =CHAT.onerror,<br />
                CHAT.socket.onmessage =CHAT.onmessage

            }<br />
            else{<br />
                alert("不支持socket");<br />
            }<br />
        },<br />
        chat: function(){<br />
            //消息发送<br />
            var content =document.getElementById("msgContent");

            if (CHAT.socket != null<br />
                    &amp;&amp; CHAT.socket != undefined<br />
                    &amp;&amp; CHAT.socket.readyState == WebSocket.OPEN) {<br />
                    CHAT.socket.send(content.value);<br />
            } else {<br />
                // 重连websocket<br />
                CHAT.init();

            }

        }<br />
        ,<br />
        //客户端与服务器链接触发<br />
        onopen :function(){

                console.log("链接已经链接");

        },<br />
        onclose :function(){<br />
                console.log("链接已经关闭");<br />
        },

        onerror:function(){<br />
            console.log("出现错误");

        },<br />
       onmessage:function(e){

                console.log("链接消息");<br />
                var reciveMsg =document.getElementById("reciveMsg");<br />
                var html =reciveMsg.innerHTML;<br />
                reciveMsg.innerHTML =html+"&lt;br/&gt;"+e.data;

        }

}

CHAT.init();

&lt;/script&gt;

&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p><strong>　　</strong></p>
<p><strong>　</strong></p>
<p>　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m22poq.html">mac显示和隐藏文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnkgr3q.html">&lbrack;POJ1765&rsqb;November Rain</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxrzdvq.html">Attempt to present &amp;lt&semi;vc&amp;gt&semi; on &amp;lt&semi;vc&amp;gt&semi; which is already presenting &amp;lt&semi;vc&amp;gt&semi;&sol;&lpar;null&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ozmr19.html">zoj3819Average Score</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mzj0gq.html">【题解】【位操作】【Leetcode】Single Number II</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdejew09.html">MySQL学习笔记（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1gwyz9.html">SublimeText的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdv5y78.html">JavaScript 滚动页面到指定元素位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj5nnr8.html">Swift迁入第三方库时的版本错误解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkom3v8.html">每一个Servlet只有一个实例，多个线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mlv6n8.html">npm 简单实用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2mdgpq.html">HTTP请求8种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90re17m9.html">Vue-cli 创建的项目配置跨域请求（通过反向代理）---配置多个代理--axios请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gzggeq.html">第K个幸运数字（4、7）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyykvwjq.html">DevExpress WinForms v18&period;2新版亮点（五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25pjklq.html">sqlalchemy 或者pysql 连接数据库时支持中文操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1ez2k9.html">Java线程池停止空闲线程是否有规则呢？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4d7o1q.html">Loadrnner 参数化策略</a>
		</li>
						<li><a href="https://www.batexi.com/a/953veo68.html">Android开发4&mdash;&mdash;文件操作模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkwjw38.html">如何写自定义的AlertView</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pw0nlk8.html">Python2 错误记录1File &amp;quot&semi;&amp;lt&semi;string&amp;gt&semi;&amp;quot&semi;&comma; line 1&comma; in &amp;lt&semi;module&amp;gt&semi; NameError&colon; name &amp;&num;39&semi;f&amp;&num;39&semi; is not defined</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ow3wq.html">应用SharedPreference保存程序的配置信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1wzxw9.html">Maven仓库&mdash;Nexus环境搭建及使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4ny6k9.html">Java IO流学习总结七：Commons IO 2&period;5-FileUtils</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m23jk6q.html">给tkinter文本框添加右键菜单</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r0vo08.html">SQL Server 优化---为什么索引视图（物化视图）需要with&lpar;noexpand&rpar;强制查询提示</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rzdmo9.html">更新package&period;json中的dependencies依赖到最新版本 -</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25omvwq.html">C&num; HttpWebRequest 错误总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1wngw9.html">MySQL 数据 导入到 SQL Service</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zydr739.html">吴裕雄 python神经网络 花朵图片识别（10）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
